package {{.Option "name"}}

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/enterprise/src/guanlixitong"
	"{{.Option "module"}}/model"
)

type Table struct {
	guanlixitong.Table
	list string `name:"list {{.Option "class"}}_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.{{.Option "CLASS"}}_TYPE:
		for k, v := range {{.Option "Class"}}TypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	case model.USER_{{.Option "CLASS"}}_ROLE:
		for k, v := range User{{.Option "Class"}}RoleList {
			if k != User{{.Option "Class"}}Creator && k != User{{.Option "Class"}}Visitor {
				m.Push(arg[0], k).Push(model.NAME, v)
			}
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.{{.Option "CLASS"}}_TYPE, func() { value = {{.Option "Class"}}Type(kit.Int(value)).String() })
		kit.If(key == model.USER_{{.Option "CLASS"}}_ROLE, func() { value = User{{.Option "Class"}}Role(kit.Int(value)).String() })
		return value
	})
	s.Table.RewriteAppend(m)
	return m
}
func (s Table) checkRole(m *ice.Message, arg ...User{{.Option "Class"}}Role) bool {
	kit.If(len(arg) == 0, func() { arg = append(arg, User{{.Option "Class"}}Leader) })
	role := User{{.Option "Class"}}Role(kit.Int(m.Cmd(user{{.Option "Class"}}{}, s.Select, m.OptionSimple(model.{{.Option "CLASS"}}_UID, model.USER_UID)).Append(model.ROLE)))
	for _, v := range append(arg, User{{.Option "Class"}}Creator) {
		if role == v {
			return true
		}
	}
	return !m.WarnNotRight(true, role.String())
}
func (s Table) recordEvent(m *ice.Message, info string, arg ...string) *ice.Message {
	s.Table.RecordEvent(m, m.Option(model.{{.Option "CLASS"}}_UID), info, kit.Select(m.Option(model.UID), arg, 0))
	return m
}

type Tables struct {
	Table
	portal string `data:"true"`
}

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}
