package yuehaoxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type call struct {
	Tables
	schedule schedule
	call     string `name:"call" help:"叫号" role:"void"`
	list     string `name:"list queue_uid uid reception_uid auto"`
	expire   string `name:"expire" role:"void"`
	finish   string `name:"finish" role:"void"`
}

func (s call) Call(m *ice.Message, arg ...string) {
	m.Cmdy(s.schedule, s.schedule.Call).Action(s.Call)
}
func (s call) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		m.Option(mdb.ORDER, model.TAKE_TIME)
		m.Cmdy(s.schedule, s.schedule.SelectByStatus, arg[0], ScheduleTake)
		kit.If(m.Length() == 0, func() { m.Echo(m.Trans("not found order", "没有等待")) }, func() { m.Action(s.Call) })
	} else if len(arg) == 2 {
		m.Cmdy(s.schedule, arg[0], arg[1]).Action(s.Call)
	} else if len(arg) == 3 {
		m.Cmdy(s.schedule, s.Select, model.QUEUE_UID, arg[0], model.RECEPTION_UID, arg[2], model.STATUS, ScheduleTake).Action(s.Call)
	}
}
func (s call) Expire(m *ice.Message, arg ...string) {
	m.Cmdy(s.schedule, s.schedule.Expire)
}
func (s call) Finish(m *ice.Message, arg ...string) {
	m.Cmdy(s.schedule, s.schedule.Finish)
}

func init() { ice.TeamCtxCmd(call{}) }
