package yuehaoxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
	"shylinux.com/x/enterprise/src/guanlixitong"
)

type Table struct {
	guanlixitong.Table
	list string `name:"list queue_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.QUEUE_TYPE:
		for k, v := range QueueTypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	case model.USER_QUEUE_ROLE:
		for k, v := range UserQueueRoleList {
			if k != UserQueueCreator && k != UserQueueVisitor {
				m.Push(arg[0], k).Push(model.NAME, v)
			}
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.QUEUE_TYPE, func() { value = QueueType(kit.Int(value)).String() })
		kit.If(key == model.USER_QUEUE_ROLE, func() { value = UserQueueRole(kit.Int(value)).String() })
		kit.If(key == model.SCHEDULE_STATUS, func() { value = ScheduleStatus(kit.Int(value)).String() })
		return value
	})
	return s.Table.RewriteAppend(m)
}
func (s Table) checkRole(m *ice.Message, arg ...UserQueueRole) bool {
	kit.If(len(arg) == 0, func() { arg = append(arg, UserQueueManager) })
	role := UserQueueRole(kit.Int(m.Cmd(userQueue{}, s.Select, m.OptionSimple(model.QUEUE_UID, model.USER_UID)).Append(model.ROLE)))
	for _, v := range append(arg, UserQueueCreator) {
		if role == v {
			return true
		}
	}
	return !m.WarnNotRight(true, role.String())
}
func (s Table) recordEvent(m *ice.Message, info string, arg ...string) *ice.Message {
	s.Table.RecordEvent(m, m.Option(model.QUEUE_UID), info, kit.Select(m.Option(model.UID), arg, 0))
	return m
}

type Tables struct {
	Table
	portal string `data:"true"`
}

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}

func newTable() Table {
	return Table{Table: guanlixitong.NewTable(userQueue{}, queue{})}
}
